*:*********************************************************************
*:
*: Procedure file: C:\BUSINESS\FOXPRO2\SRCH\ALL_SRCH.PRG
*:
*:         System: INCREMENTAL BROWSE UTILITY
*:         Author: PAUL BIENICK
*:      Copyright (c) 1992, PAUL BIENICK
*:  Last modified: 03/09/93      8:59
*:
*:  Procs & Fncts: SRCHERR
*:               : RESTORENV
*:
*:          Calls: SRCHERR            (procedure in ALL_SRCH.PRG)
*:               : JKEYINIT()         (function  in ?)
*:               : RESTORENV          (procedure in ALL_SRCH.PRG)
*:
*:           Uses: LOCFILE(DBF,"DBF","
*:
*: ALL_SRCH Version 1.3
*:
*:      Documented 03/25/93 at 09:19               FoxDoc  version 2.10
*:*********************************************************************

parameters Dbf, Ord, FieldToRtn, StartRow, StartCol, Size,;
  Title, Prompt, ForClause, KeyClause,;
  f0, h0, f1, h1, f2, h2, f3, h3, f4, h4, f5, h5, f6, h6,;
  f7, h7, f8, h8, f9, h9


private all

if parameters() < 3
  return ""
endif

* Initial setup
kbEsc = 27
kbCtrl_W = 23
kbEnter = 13
FirstFld = 10                    && position in parm list of first field parameter (f0)
ErrorHdl = on('error')

* I temporily disable the error routine here, and initialize 
* with a custom routine at the bottom of this program. It made
* debugging easier, since I wanted the library to be unloaded
* immediately. 

on error *

* Feel free to play with the colors. Remember that are 3 windows
* defined here. One for the background window, one for the talk
* window (which is where the user enters the search criteria), and
* the browse window. If you want to set up custom color schemes,
* just change the lines below.


BackColor = "N/W,W+/BG,N/W,N/W,N/W,RB/W,GR+/RB,N+/N,BG+/W,N+/W,+"
BrowColor = "W+/B,N/W,W/B,B/B,B/B,N/W,N/W,N+/N,GR+/B,R+/B,-"

*BackColor = scheme(23)
*BrowColor = scheme(24)

TalkStat = set('talk')
set talk off

NumFlds = parameters() - FirstFld                       && number of fields to display in brow
RtnFld = ""


* if you don't want to automatically go to the top
* of the file if the table you're searching is
* already open, remove the 'go top' at the bottom
* of the next code section.

* use or open the desired database and set the order
CurDbf = alias()
if !used(Dbf)
  sele 0
  use locfile(Dbf,"DBF","Where is "+Dbf+"?") order Ord
  if lastkey() = kbEsc or empty(alias()) or alias() != upper(Dbf)
    ?? chr(7)
    wait window nowait "COULD NOT FIND REQUESTED DATABASE"
    if alias() != upper(Dbf)
      use
    endif
    if !empty(CurDbf)
      sele (CurDbf)
    endif
    on error &ErrorHdl
    set talk &TalkStat
    return iif(FieldToRtn = "#",0,"")
  endif
  CurOrd = ""
  CloseIt = .t. && (close the database later)
else
  sele (Dbf)
  CurOrd = order()
  set order to 0 && this is done to validate the tag instead of looping through all of them with tag(i)
  set order to Ord
  CloseIt = .f. && (do not close it)
endif
if empty(order()) && tag was not set correctly
  if CloseIt
    use
  else
    if !empty(CurOrd)
      set order to CurOrd
    endif
  endif
  if !empty(CurDbf)
    sele (CurDbf)
  endif
  ?? chr(7)
  wait window nowait "INDEX TAG NOT FOUND"
  on error &ErrorHdl
  set talk &TalkStat
  return iif(FieldToRtn = "#",0,"")
endif
go top


* verify that FieldToRtn is a valid field
if type('FieldToRtn') = "C"
  if FieldToRtn != "#"
    for i = 1 to fcount()
      if upper(FieldToRtn) = field(i)
	RtnFld = FieldToRtn
	exit
      endif
    endfor
    if empty(RtnFld)
      ?? chr(7)
      wait window nowait "RETURN FIELD: " + FieldToRtn + " IS NOT VALID"
      on error &ErrorHdl
      set talk &TalkStat
      return ""
    endif
  else
    RtnFld = 0
  endif
else
  ?? chr(7)
  wait window nowait "RETURN FIELD PARAMETER MUST BE OF TYPE CHARACTER"
  on error &ErrorHdl
  set talk &TalkStat
  return 0
endif

on error do SrchErr with message(1),lineno(1)

* set title and prompt
Title = iif(type('Title') != "C" or empty(Title), "< Pick List >", Title)
if type('Prompt') = "U" or empty(Prompt)
  Prompt = "Search For: "
endif



* calculate width of browse window by summing lengths of fields to display
MaxRows = srows()
MaxCols = scols()
MinBrowWidth = max(len(Title),len(Prompt)) + 5
MaxBrowWidth = MaxCols - 4
BrwseWidth = 0
if NumFlds > 0
  for i = 0 to int((NumFlds + 1) / 2) - 1
    FieldParm = "f" + alltrim(str(i,2))
    if at(".",eval(FieldParm)) = 0                      && no dbf alias
      BrwseWidth = BrwseWidth + max((fsize(eval("f"+alltrim(str(i,2)))) + 2),;
	(len(eval("h"+alltrim(str(i,2)))) + 2))
    else
      if at('iif',eval(FieldParm)) = 0  && if the parameter does not contain 'iif'
	mAlias = left(eval(FieldParm),at(".",eval(FieldParm))-1)
	mField = substr(eval(FieldParm), at(".",eval(FieldParm))+1)
	BrwseWidth = BrwseWidth + max(fsize(mField,mAlias) + 2,;
	  (len(eval("h"+alltrim(str(i,2))))+2))
      else

	* if field contains a conditional 'iif' as well as the
	* field alias, take the length of the heading as the default
	* for sanity's sake!
	BrwseWidth = BrwseWidth + max(len(eval("h"+alltrim(str(i,2))))+2,2)
      endif
    endif
  endfor
else
  BrwseWidth = min(recsize(),MaxBrowWidth)
endif
BrwseWidth = BrwseWidth + 2 && for borders & grid
BrwseWidth = iif(BrwseWidth > MaxBrowWidth, MaxBrowWidth, BrwseWidth)
BrwseWidth = iif(BrwseWidth < MinBrowWidth, MinBrowWidth, BrwseWidth)


*
* The following code section has been 'remmed out'
* to save processing time. It was used to auto-size
* the window based on the number of records in the
* table. RecCnt is now hard-coded after this section.
*
* calculate height of browse window
* first get number of recs
* note: this won't be accurate if 'key' clause is used
*if type('ForClause') = "C"
*  if empty(ForClause)
*    RecCnt = reccount()
*  else
*    count to RecCnt for &ForClause && use macro subst here-Rushmore
*  endif                                                                                                  && cannot optimize EVAL()
*else
*  RecCnt = reccount()
*endif

* Hardcode the RecCnt variable here so the rest of the 
* code can remain unchanged.
RecCnt = 10


ReqBrowHeight = 11
MaxBrowHeight = MaxRows - 2
MinBrowHeight = 9

* if Size is specified and it's value within range, leave it alone.
* if no size specified, set size to greater of Minimun Browse Height
* and # of records + 7
Size = iif(type('Size') = "N" and Size >= MinBrowHeight and Size <= MaxBrowHeight,;
  Size, max(MinBrowHeight,RecCnt + 7))

* if no start column specified, set to center on screen
StartCol = iif(type('StartCol') != "N" or !between(StartCol,0,Maxcols),;
  int((MaxCols - BrwseWidth) / 2) - 1,StartCol)

* to auto adjust start column to fit the browse, uncomment next line
* and comment the line after
*StartCol = iif(StartCol + BrwseWidth <= MaxCols, StartCol,;
*  iif((MaxCols - BrwseWidth) - 3 > 0,;
*  (MaxCols - BrwseWidth) - 3, 1))

* to auto adjust the browse width to fit the browse, uncomment next
* line and comment previous line
BrwseWidth = iif(StartCol + BrwseWidth <= MaxCols, BrwseWidth,;
  max(MinBrowWidth, (Maxcols    - StartCol) - 3))


* I 'remmed-out' the auto-adjusting of the Starting row
* because I thought the window would look better if it would
* just center itself on the screen. The auto-centering takes
* place after the next section.

* if no start row specified, if window on top, use windows top
* row. If no window on top, use value of row()
*StartRow = iif(type('StartRow') != "N" or StartRow < 0,;
*  iif(!empty(wontop()),wlrow(),;
*  row()), StartRow)

StartRow = iif(type('StartRow') = 'N', StartRow,;
		int((MaxRows - Size) / 2) - 1)


* auto adjust start row if necessary
StartRow = iif(StartRow > MaxRows - ReqBrowHeight,;
  MaxRows - ReqBrowHeight, StartRow)

* calculate available # of rows
AvailRows = MaxBrowHeight - StartRow

* auto adjust browse height if necessary
BrwseHeight = iif(between(Size,MinBrowHeight,AvailRows), Size,;
  min(AvailRows,RecCnt + 5))


define window backgrnd;
  from StartRow, StartCol;
  to StartRow + BrwseHeight, StartCol + BrwseWidth;
  nofloat nogrow nozoom shadow;
  title Title;
  color (BackColor) && scheme 23
define window talkwind ;
  from StartRow + 1, StartCol + 1;
  to StartRow + 2, StartCol + BrwseWidth - 1;
  nofloat nogrow nozoom noshadow none;
  color (BackColor) && scheme 23
define window browwind ;
  from StartRow + 3, StartCol + 1;
  to StartRow + BrwseHeight - 1, StartCol + BrwseWidth - 1;
  nofloat nogrow nozoom noshadow;
  color (BrowColor) && scheme 24



* build browse command
if NumFlds > 0
  BrwseCommand = "browse fields "
  Cnt = int((NumFlds + 1) /2) -1
  for i = 0 to Cnt
    Heading = "h" + alltrim(str(i,2))
    Field = "f" + alltrim(str(i,2))
    CondIf = iif(at("iif",lower(eval(Field))) > 0, .t., .f.) && 'iif' statement present?
    BrwseCommand = BrwseCommand + iif(CondIf,"&","(")+;
      "f" + alltrim(str(i,2)) + iif(CondIf,"",")");
      + iif(!empty(eval(Heading)),;
      ":H = '" + eval(Heading) + "'" + iif(i < Cnt,", "," "),;
      iif(i < Cnt,", "," "))
  endfor
else
  BrwseCommand = "browse "
endif

* add 'for' clause
if type('ForClause') = "C"
  if !empty(ForClause)
    BrwseCommand = BrwseCommand + "FOR " + alltrim(ForClause) + " "
  endif
endif

* add 'key' clause
if type('KeyClause') = "C"
  if !empty(KeyClause)
    BrwseCommand = BrwseCommand + "KEY " + alltrim(KeyClause) + " "
  endif
endif

* make sure browse window title is blanked out. Title will
* appear in the parent window instead.
BrwseCommand = BrwseCommand + "TITLE ' ' "

* other options
BrwseCommand = BrwseCommand + "window browwind nomodify nomenu noappend nodelete"


* set up environment settings
* this is done way down here to insure that
* everthing else went ok - strange things have
* happened when this library was not released properly

MenuStat = set('sysmenu')
CursStat = set('cursor')
BellStat = set('bell')
ExactStat = set('exact')
NearStat = set('near')
push key clear
on key label enter && necessary in case this is the first time
*                                                                                       we are setting an 'on key' for 'enter'. If we don't
*                                                                                       do this, pop key will not clear the setting!

set library to jkey additive
set sysmenu off
set cursor off
set bell off
set exact off
set near on
on key label enter keyboard "{ctrl+w}"

activate window backgrnd
activate window talkwind

SecondComma = at(",",BackColor,2)
ThirdComma = at(",",BackColor,3)
@ 1,0  to 1,WCOLS() color (substr(BackColor, SecondComma+1,(ThirdComma - SecondComma)-1))
@ 0,0 say Prompt

* let's do it!
=jkeyinit("A","","*","")
activate window browwind
&BrwseCommand

if lastkey() = kbCtrl_W or lastkey() = kbEnter
  RtnFld = iif(FieldToRtn = "#", recno(), eval(RtnFld))
else
  RtnFld = iif(FieldToRtn = "#", 0, "")
endif

do RestorEnv

if TalkStat = "ON"
  set talk on
endif

return RtnFld


*!*********************************************************************
*!
*!      Procedure: RESTORENV
*!
*!      Called by: ALL_SRCH.PRG                      
*!               : SRCHERR            (procedure in ALL_SRCH.PRG)
*!
*!          Calls: JKEYCANC()         (function  in ?)
*!
*!*********************************************************************
procedure RestorEnv
* restore environment

* first thing to do is stop jkey from handling our keyboard
if "jkey" $ upper(set('library'))
  =jkeycanc()
endif

if CloseIt
  use
else
  if !empty(CurOrd)
    set order to CurOrd
  endif
endif
if !empty(CurDbf)
  sele (CurDbf)
endif

release window browwind
release window talkwind
release window backgrnd
release library jkey

if type("MenuStat") != "U"
  if MenuStat != "OFF"
    set sysmenu &MenuStat
  endif
endif

if type('CursStat') != "U"
  set cursor &CursStat
endif

if type('BellStat') != "U"
  if BellStat = "OFF"
    set bell off
  endif
endif

if type('ExactStat') != "U"
	if ExactStat = "ON"
		set exact on
	endif
endif

if type('NearStat') != "U"
	if NearStat = "OFF"
		set near off
	endif
endif

pop key

if !empty(ErrorHdl)
  on error &ErrorHdl
else
  on error
endif

return


*!*********************************************************************
*!
*!      Procedure: SRCHERR
*!
*!      Called by: ALL_SRCH.PRG                      
*!
*!          Calls: RESTORENV          (procedure in ALL_SRCH.PRG)
*!
*!*********************************************************************
procedure SrchErr
parameters msg,lineno
* Traps errors within this program and insures that
* the jkey library is released from memory.

?? chr(7)
wait window msg +" at line " +  str(lineno,4) timeout 2

if type('TalkStat') != "U"
  if TalkStat = "OFF"
    set talk off
  endif
endif

do RestorEnv



if lastkey() = kbCtrl_W or lastkey() = kbEnter
  RtnFld = iif(FieldToRtn = "#",0,"")
endif


suspend

*: EOF: ALL_SRCH.PRG
