* The easiest way to use the examples is to
* copy the jkey.plb file into the directory
* that contains the all_srch.prg program, the
* example.prg program, and the INMAST and
* INTYPE sample data files. Make sure that
* this directory is in your Foxpro search
* path.


* Note that we are ingoring the return
* code in all of the following examples.

* Although it's not necessary to open the
* tables we wish to search, it tends to
* speed up the program a bit.

set talk off
close data
sele 0
use locfile("INTYPE","DBF","Where is INTYPE.DBF?");
		order TYPE

sele 0
use locfile("INMAST","DBF","Where is INMAST.DBF?")



* EXAMPLE 1

* The simplest way to get started:

clear
@ 1,1 say '=all_srch("INMAST","PART","PART")'

=all_srch("INMAST","PART","PART")

*	DBF: "INMAST"
* TAG: "PART"
* RETURN FIELD: "PART"

 

* EXAMPLE 2

* A little more involved:

clear
@ 1,1 say '=all_srch("INMAST","PART","PART",;'
@ 2,1 say '    10, 5, 15, "Part Search Window",;'
@ 3,1 say '    "ENTER PART NUMBER:")'

=all_srch("INMAST","PART","PART",;
					10, 5, 15, "Part Search Window",;
					"ENTER PART NUMBER:")
					
* DBF, TAG, RETURN FIELD same as ex1.

* Display browse window at:
* 		   row: 10
*			column: 5					
*
* with a size (height) of: 15
* and a title: "Part Search Window".
*
* Prompt string = "ENTER PART NUMBER:"


* EXAMPLE 3
* same as ex2 except we skip the
* optional 'FOR' and 'KEY' clauses
* and specify some fields

clear
@ 1,1 say '=all_srch("INMAST","PART","PART",;'
@ 2,1 say '    10, 5, 15, "Part Search Window",;'
@ 3,1 say '    "ENTER PART NUMBER:",;'
@ 4,1 say '    "","",;'
@ 5,1 say '    "PART","<PART NUMBER>",;'
@ 6,1 say '    "DESC","<DESCRIPTION>",;'
@ 7,1 say '    "ON_HAND","<QTY ON HAND>")'


=all_srch("INMAST","PART","PART",;
					10, 5, 15, "Part Search Window",;
					"ENTER PART NUMBER:",;
					"","",;
					"PART","<PART NUMBER>",;
					"DESC","<DESCRIPTION>",;
					"ON_HAND","<QTY ON HAND>")
					
* EXAMPLE 4
* same as ex3 but include a 'FOR' clause
* to just see parts where the on hand
* quantity (ON_HAND) is greater than 20

clear
@ 1,1 say '=all_srch("INMAST","PART","PART",;'
@ 2,1 say '    10, 5, 15, "Part Search Window",;'
@ 3,1 say '    "ENTER PART NUMBER:",;'
@ 4,1 say '    "ON_HAND > 20","",;'
@ 5,1 say '    "PART","<PART NUMBER>",;'
@ 6,1 say '    "DESC","<DESCRIPTION>",;'
@ 7,1 say '    "ON_HAND","<QTY ON HAND>")'



=all_srch("INMAST","PART","PART",;
					10, 5, 15, "Part Search Window",;
					"ENTER PART NUMBER:",;
					"ON_HAND > 20","",;
					"PART","<PART NUMBER>",;
					"DESC","<DESCRIPTION>",;
					"ON_HAND","<QTY ON HAND>")
					
					
* EXAMPLE 5
* similar to ex4 with the following changes:
*		remove the 'FOR' clause
*		display all parts. If on hand quantity
*		is greater than 20, then display the
*   message "OVER 20", otherwise display
*   nothing.
*
* Note that the 'A = ..." is necessary so
* that all_srch can properly build the
* browse command. It's just a 'DUMMY'
* field name. You need to specify a 
* unique 'DUMMY' field name for each 
* 'IIF' statement you use.

clear
@ 1,1 say '=all_srch("INMAST","PART","PART",;'
@ 2,1 say '    10, 5, 15, "Part Search Window",;'
@ 3,1 say '    "ENTER PART NUMBER:",;'
@ 4,1 say '    "","",;'
@ 5,1 say '    "PART","<PART NUMBER>",;'
@ 6,1 say '    "DESC","<DESCRIPTION>",;'
@ 7,1 say [    "A = IIF(ON_HAND > 20, 'OVER 20',' ')","<QTY ON HAND>")]



=all_srch("INMAST","PART","PART",;
					10, 5, 15, "Part Search Window",;
					"ENTER PART NUMBER:",;
					"","",;
					"PART","<PART NUMBER>",;
					"DESC","<DESCRIPTION>",;
					"A = IIF(ON_HAND > 20, 'OVER 20',' ')","<QTY ON HAND>")
					
* EXAMPLE 6
* similar to ex4 but:
*		let all_srch size the window
*		remove the 'FOR' clause
*		remove "PART DESCRIPTION" from 
*			the field list
*		set up relation with INTYPE and
*		display the type description - 
*		(INTYPE.DESC)

select INMAST
set relation to TYPE into INTYPE


clear
@ 1,1 say '=all_srch("INMAST","PART","PART",;'
@ 2,1 say '    "", "", "", "Part Search Window",;'
@ 3,1 say '    "ENTER PART NUMBER:",;'
@ 4,1 say '    "","",;'
@ 5,1 say '    "PART","<PART NUMBER>",;'
@ 6,1 say '    "TYPE","<PART TYPE>",;'
@ 7,1 say '    "INTYPE.DESC","<TYPE DESCRIPTION>")'


=all_srch("INMAST","PART","PART",;
					"", "", "", "Part Search Window",;
					"ENTER PART NUMBER:",;
					"","",;
					"PART","<PART NUMBER>",;
					"TYPE","<PART TYPE>",;
					"INTYPE.DESC","<TYPE DESCRIPTION>")
